// Code generated by github.com/Khan/genqlient, DO NOT EDIT.

package gitlabgraphql

import (
	"context"

	"github.com/Khan/genqlient/graphql"
)

// GetPipelineJobNeedsProject includes the requested fields of the GraphQL type Project.
type GetPipelineJobNeedsProject struct {
	// Pipeline of the project. If no arguments are provided, returns the latest
	// pipeline for the head commit on the default branch
	Pipeline GetPipelineJobNeedsProjectPipeline `json:"pipeline"`
}

// GetPipeline returns GetPipelineJobNeedsProject.Pipeline, and is useful for accessing the field via an interface.
func (v *GetPipelineJobNeedsProject) GetPipeline() GetPipelineJobNeedsProjectPipeline {
	return v.Pipeline
}

// GetPipelineJobNeedsProjectPipeline includes the requested fields of the GraphQL type Pipeline.
type GetPipelineJobNeedsProjectPipeline struct {
	// Jobs belonging to the pipeline.
	Jobs GetPipelineJobNeedsProjectPipelineJobsCiJobConnection `json:"jobs"`
}

// GetJobs returns GetPipelineJobNeedsProjectPipeline.Jobs, and is useful for accessing the field via an interface.
func (v *GetPipelineJobNeedsProjectPipeline) GetJobs() GetPipelineJobNeedsProjectPipelineJobsCiJobConnection {
	return v.Jobs
}

// GetPipelineJobNeedsProjectPipelineJobsCiJobConnection includes the requested fields of the GraphQL type CiJobConnection.
// The GraphQL type's documentation follows.
//
// The connection type for CiJob.
type GetPipelineJobNeedsProjectPipelineJobsCiJobConnection struct {
	// A list of edges.
	Edges []GetPipelineJobNeedsProjectPipelineJobsCiJobConnectionEdgesCiJobEdge `json:"edges"`
}

// GetEdges returns GetPipelineJobNeedsProjectPipelineJobsCiJobConnection.Edges, and is useful for accessing the field via an interface.
func (v *GetPipelineJobNeedsProjectPipelineJobsCiJobConnection) GetEdges() []GetPipelineJobNeedsProjectPipelineJobsCiJobConnectionEdgesCiJobEdge {
	return v.Edges
}

// GetPipelineJobNeedsProjectPipelineJobsCiJobConnectionEdgesCiJobEdge includes the requested fields of the GraphQL type CiJobEdge.
// The GraphQL type's documentation follows.
//
// An edge in a connection.
type GetPipelineJobNeedsProjectPipelineJobsCiJobConnectionEdgesCiJobEdge struct {
	// The item at the end of the edge.
	Node GetPipelineJobNeedsProjectPipelineJobsCiJobConnectionEdgesCiJobEdgeNodeCiJob `json:"node"`
}

// GetNode returns GetPipelineJobNeedsProjectPipelineJobsCiJobConnectionEdgesCiJobEdge.Node, and is useful for accessing the field via an interface.
func (v *GetPipelineJobNeedsProjectPipelineJobsCiJobConnectionEdgesCiJobEdge) GetNode() GetPipelineJobNeedsProjectPipelineJobsCiJobConnectionEdgesCiJobEdgeNodeCiJob {
	return v.Node
}

// GetPipelineJobNeedsProjectPipelineJobsCiJobConnectionEdgesCiJobEdgeNodeCiJob includes the requested fields of the GraphQL type CiJob.
type GetPipelineJobNeedsProjectPipelineJobsCiJobConnectionEdgesCiJobEdgeNodeCiJob struct {
	// Name of the job.
	Name string `json:"name"`
	// References to builds that must complete before the jobs run.
	Needs GetPipelineJobNeedsProjectPipelineJobsCiJobConnectionEdgesCiJobEdgeNodeCiJobNeedsCiBuildNeedConnection `json:"needs"`
}

// GetName returns GetPipelineJobNeedsProjectPipelineJobsCiJobConnectionEdgesCiJobEdgeNodeCiJob.Name, and is useful for accessing the field via an interface.
func (v *GetPipelineJobNeedsProjectPipelineJobsCiJobConnectionEdgesCiJobEdgeNodeCiJob) GetName() string {
	return v.Name
}

// GetNeeds returns GetPipelineJobNeedsProjectPipelineJobsCiJobConnectionEdgesCiJobEdgeNodeCiJob.Needs, and is useful for accessing the field via an interface.
func (v *GetPipelineJobNeedsProjectPipelineJobsCiJobConnectionEdgesCiJobEdgeNodeCiJob) GetNeeds() GetPipelineJobNeedsProjectPipelineJobsCiJobConnectionEdgesCiJobEdgeNodeCiJobNeedsCiBuildNeedConnection {
	return v.Needs
}

// GetPipelineJobNeedsProjectPipelineJobsCiJobConnectionEdgesCiJobEdgeNodeCiJobNeedsCiBuildNeedConnection includes the requested fields of the GraphQL type CiBuildNeedConnection.
// The GraphQL type's documentation follows.
//
// The connection type for CiBuildNeed.
type GetPipelineJobNeedsProjectPipelineJobsCiJobConnectionEdgesCiJobEdgeNodeCiJobNeedsCiBuildNeedConnection struct {
	// A list of edges.
	Edges []GetPipelineJobNeedsProjectPipelineJobsCiJobConnectionEdgesCiJobEdgeNodeCiJobNeedsCiBuildNeedConnectionEdgesCiBuildNeedEdge `json:"edges"`
}

// GetEdges returns GetPipelineJobNeedsProjectPipelineJobsCiJobConnectionEdgesCiJobEdgeNodeCiJobNeedsCiBuildNeedConnection.Edges, and is useful for accessing the field via an interface.
func (v *GetPipelineJobNeedsProjectPipelineJobsCiJobConnectionEdgesCiJobEdgeNodeCiJobNeedsCiBuildNeedConnection) GetEdges() []GetPipelineJobNeedsProjectPipelineJobsCiJobConnectionEdgesCiJobEdgeNodeCiJobNeedsCiBuildNeedConnectionEdgesCiBuildNeedEdge {
	return v.Edges
}

// GetPipelineJobNeedsProjectPipelineJobsCiJobConnectionEdgesCiJobEdgeNodeCiJobNeedsCiBuildNeedConnectionEdgesCiBuildNeedEdge includes the requested fields of the GraphQL type CiBuildNeedEdge.
// The GraphQL type's documentation follows.
//
// An edge in a connection.
type GetPipelineJobNeedsProjectPipelineJobsCiJobConnectionEdgesCiJobEdgeNodeCiJobNeedsCiBuildNeedConnectionEdgesCiBuildNeedEdge struct {
	// The item at the end of the edge.
	Node GetPipelineJobNeedsProjectPipelineJobsCiJobConnectionEdgesCiJobEdgeNodeCiJobNeedsCiBuildNeedConnectionEdgesCiBuildNeedEdgeNodeCiBuildNeed `json:"node"`
}

// GetNode returns GetPipelineJobNeedsProjectPipelineJobsCiJobConnectionEdgesCiJobEdgeNodeCiJobNeedsCiBuildNeedConnectionEdgesCiBuildNeedEdge.Node, and is useful for accessing the field via an interface.
func (v *GetPipelineJobNeedsProjectPipelineJobsCiJobConnectionEdgesCiJobEdgeNodeCiJobNeedsCiBuildNeedConnectionEdgesCiBuildNeedEdge) GetNode() GetPipelineJobNeedsProjectPipelineJobsCiJobConnectionEdgesCiJobEdgeNodeCiJobNeedsCiBuildNeedConnectionEdgesCiBuildNeedEdgeNodeCiBuildNeed {
	return v.Node
}

// GetPipelineJobNeedsProjectPipelineJobsCiJobConnectionEdgesCiJobEdgeNodeCiJobNeedsCiBuildNeedConnectionEdgesCiBuildNeedEdgeNodeCiBuildNeed includes the requested fields of the GraphQL type CiBuildNeed.
type GetPipelineJobNeedsProjectPipelineJobsCiJobConnectionEdgesCiJobEdgeNodeCiJobNeedsCiBuildNeedConnectionEdgesCiBuildNeedEdgeNodeCiBuildNeed struct {
	// Name of the job we need to complete.
	Name string `json:"name"`
}

// GetName returns GetPipelineJobNeedsProjectPipelineJobsCiJobConnectionEdgesCiJobEdgeNodeCiJobNeedsCiBuildNeedConnectionEdgesCiBuildNeedEdgeNodeCiBuildNeed.Name, and is useful for accessing the field via an interface.
func (v *GetPipelineJobNeedsProjectPipelineJobsCiJobConnectionEdgesCiJobEdgeNodeCiJobNeedsCiBuildNeedConnectionEdgesCiBuildNeedEdgeNodeCiBuildNeed) GetName() string {
	return v.Name
}

// GetPipelineJobNeedsResponse is returned by GetPipelineJobNeeds on success.
type GetPipelineJobNeedsResponse struct {
	// Find a project.
	Project GetPipelineJobNeedsProject `json:"project"`
}

// GetProject returns GetPipelineJobNeedsResponse.Project, and is useful for accessing the field via an interface.
func (v *GetPipelineJobNeedsResponse) GetProject() GetPipelineJobNeedsProject { return v.Project }

// __GetPipelineJobNeedsInput is used internally by genqlient
type __GetPipelineJobNeedsInput struct {
	Project     string `json:"project"`
	Pipeline_id string `json:"pipeline_id"`
}

// GetProject returns __GetPipelineJobNeedsInput.Project, and is useful for accessing the field via an interface.
func (v *__GetPipelineJobNeedsInput) GetProject() string { return v.Project }

// GetPipeline_id returns __GetPipelineJobNeedsInput.Pipeline_id, and is useful for accessing the field via an interface.
func (v *__GetPipelineJobNeedsInput) GetPipeline_id() string { return v.Pipeline_id }

// The query executed by GetPipelineJobNeeds.
const GetPipelineJobNeeds_Operation = `
query GetPipelineJobNeeds ($project: ID!, $pipeline_id: CiPipelineID!) {
	project(fullPath: $project) {
		pipeline(id: $pipeline_id) {
			jobs {
				edges {
					node {
						name
						needs {
							edges {
								node {
									name
								}
							}
						}
					}
				}
			}
		}
	}
}
`

func GetPipelineJobNeeds(
	ctx_ context.Context,
	client_ graphql.Client,
	project string,
	pipeline_id string,
) (data_ *GetPipelineJobNeedsResponse, err_ error) {
	req_ := &graphql.Request{
		OpName: "GetPipelineJobNeeds",
		Query:  GetPipelineJobNeeds_Operation,
		Variables: &__GetPipelineJobNeedsInput{
			Project:     project,
			Pipeline_id: pipeline_id,
		},
	}

	data_ = &GetPipelineJobNeedsResponse{}
	resp_ := &graphql.Response{Data: data_}

	err_ = client_.MakeRequest(
		ctx_,
		req_,
		resp_,
	)

	return data_, err_
}
